unit MainFrm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Borland.Vcl.ExtCtrls, Borland.Vcl.StdCtrls, System.ComponentModel,
  CAD, Borland.Vcl.Buttons, Borland.Vcl.ExtDlgs;

type
  TMainForm = class(TForm)
    MyCAD1: TMyCAD;
    Panel1: TPanel;
    lblColorBegin: TLabel;
    lblColorEnd: TLabel;
    lblGradientStyle: TLabel;
    cmbGradientStyle: TComboBox;
    cbColorBegin: TColorBox;
    cbColorEnd: TColorBox;
    sbSelecting: TSpeedButton;
    sbRotateSelecting: TSpeedButton;
    sbLine: TSpeedButton;
    sbRuleLine: TSpeedButton;
    sbLinkLine: TSpeedButton;
    sbPolyLine: TSpeedButton;
    sbPolygon: TSpeedButton;
    sbRectangle: TSpeedButton;
    sbImage: TSpeedButton;
    sbEllipse: TSpeedButton;
    sbText: TSpeedButton;
    sbLineLinkLine: TSpeedButton;
    sbPolyBezier: TSpeedButton;
    sbElliArc: TSpeedButton;
    sbRemoveAPoint: TSpeedButton;
    sbAddAPoint: TSpeedButton;
    lblCodeidea: TLabel;
    btnClose: TButton;
    OpenPictureDialog1: TOpenPictureDialog;
    btnFlipHorizontal: TButton;
    btnFlipVertical: TButton;
    procedure MyCAD1ActionToolToSelecting;
    procedure btnFlipVerticalClick(Sender: TObject);
    procedure btnFlipHorizontalClick(Sender: TObject);
    procedure cmbGradientStyleChange(Sender: TObject);
    procedure cbColorEndChange(Sender: TObject);
    procedure cbColorBeginChange(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure sbLineLinkLineClick(Sender: TObject);
    procedure sbLinkLineClick(Sender: TObject);
    procedure sbTextClick(Sender: TObject);
    procedure sbImageClick(Sender: TObject);
    procedure sbElliArcClick(Sender: TObject);
    procedure sbPolyBezierClick(Sender: TObject);
    procedure sbEllipseClick(Sender: TObject);
    procedure sbRectangleClick(Sender: TObject);
    procedure sbRemoveAPointClick(Sender: TObject);
    procedure sbAddAPointClick(Sender: TObject);
    procedure sbPolygonClick(Sender: TObject);
    procedure sbPolyLineClick(Sender: TObject);
    procedure sbRuleLineClick(Sender: TObject);
    procedure sbLineClick(Sender: TObject);
    procedure sbRotateSelectingClick(Sender: TObject);
    procedure sbSelectingClick(Sender: TObject);
    procedure MyCAD1ShapeAdded(var AShape: TMyShape; ShapeCount: Integer);
    procedure MyCAD1ShapeSelected(LastSelectedShape, SelectedShape: TMyShape);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.nfm}

procedure TMainForm.MyCAD1ShapeSelected(LastSelectedShape,
  SelectedShape: TMyShape);
begin
  //Get selected shape's begin color,end color and gradient style.
  cbColorBegin.Selected:=SelectedShape.ColorBegin;
  cbColorEnd.Selected:=SelectedShape.ColorEnd;
  cmbGradientStyle.ItemIndex:=Convert.ToInt32(SelectedShape.GradientStyle);
end;

procedure TMainForm.MyCAD1ShapeAdded(var AShape: TMyShape; ShapeCount: Integer);
var
  ABitmap:TBitmap;
begin
  //Open a picture dialog when add a image shape.
  if AShape <> nil then
    if AShape.ClassName = 'TMyImage' then
      if OpenPictureDialog1.Execute then
      begin
        ABitmap:=  LoadGraphicsFile(OpenPictureDialog1.FileName);
        MyCAD1.SetMyImage(AShape.ShapeId,ABitmap) ;
        ABitmap.Free;
      end;
  //Get added shape's begin color,end color and gradient style.
  cbColorBegin.Selected:=AShape.ColorBegin;
  cbColorEnd.Selected:=AShape.ColorEnd;
  cmbGradientStyle.ItemIndex:=Convert.ToInt32(AShape.GradientStyle);
end;

procedure TMainForm.sbSelectingClick(Sender: TObject);
begin
  MyCAD1.ShapeTool:=spSelecting;
end;

procedure TMainForm.sbRotateSelectingClick(Sender: TObject);
begin
  MyCAD1.ShapeTool:=spRotateSelecting;
end;

procedure TMainForm.sbLineClick(Sender: TObject);
begin
  MyCAD1.ShapeTool:=spLine;
end;

procedure TMainForm.sbRuleLineClick(Sender: TObject);
begin
  MyCAD1.ShapeTool:=spRuleLine;
end;

procedure TMainForm.sbPolyLineClick(Sender: TObject);
begin
  MyCAD1.ShapeTool:=spPolyLine;
end;

procedure TMainForm.sbPolygonClick(Sender: TObject);
begin
  MyCAD1.ShapeTool:=spPolygon;
end;

procedure TMainForm.sbAddAPointClick(Sender: TObject);
begin
  MyCAD1.ShapeTool:=SpPolylinePolygonPointAdding;
end;

procedure TMainForm.sbRemoveAPointClick(Sender: TObject);
begin
  MyCAD1.ShapeTool:=SpPolylinePolygonPointRemoving;
end;

procedure TMainForm.sbRectangleClick(Sender: TObject);
begin
  MyCAD1.ShapeTool:=spRectangle;
end;

procedure TMainForm.sbEllipseClick(Sender: TObject);
begin
  MyCAD1.ShapeTool:=spEllipse;
end;

procedure TMainForm.sbPolyBezierClick(Sender: TObject);
begin
  MyCAD1.ShapeTool:=spPolyBezier;
end;

procedure TMainForm.sbElliArcClick(Sender: TObject);
begin
  MyCAD1.ShapeTool:=spElliArc;
end;

procedure TMainForm.sbImageClick(Sender: TObject);
begin
  MyCAD1.ShapeTool:=spImage;
end;

procedure TMainForm.sbTextClick(Sender: TObject);
begin
  MyCAD1.ShapeTool:=spText;
end;

procedure TMainForm.sbLinkLineClick(Sender: TObject);
begin
  MyCAD1.ShapeTool:=spLinkLine;
end;

procedure TMainForm.sbLineLinkLineClick(Sender: TObject);
begin
  MyCAD1.ShapeTool:=spLineLinkLine;
end;

procedure TMainForm.btnCloseClick(Sender: TObject);
begin
  Close;
  Application.Terminate;
end;

procedure TMainForm.cbColorBeginChange(Sender: TObject);
begin
  if MyCAD1.GetSelectedShape <> nil then
    MyCAD1.GetSelectedShape.ColorBegin := cbColorBegin.Selected;
end;

procedure TMainForm.cbColorEndChange(Sender: TObject);
begin
  if MyCAD1.GetSelectedShape <> nil then
    MyCAD1.GetSelectedShape.ColorEnd := cbColorEnd.Selected;
end;

procedure TMainForm.cmbGradientStyleChange(Sender: TObject);
begin
  if MyCAD1.GetSelectedShape <> nil then
    MyCAD1.GetSelectedShape.GradientStyle := TGradientStyle(cmbGradientStyle.ItemIndex);
end;

procedure TMainForm.btnFlipHorizontalClick(Sender: TObject);
begin
  if MyCAD1.GetSelectedShape <> nil then
    MyCAD1.FlipHoriz(MyCAD1.GetSelectedShape);
end;

procedure TMainForm.btnFlipVerticalClick(Sender: TObject);
begin
  if MyCAD1.GetSelectedShape <> nil then
    MyCAD1.FlipVert(MyCAD1.GetSelectedShape);
end;

procedure TMainForm.MyCAD1ActionToolToSelecting;
begin
  sbSelecting.Down:=true;
end;

end.
